package org.eclipse.gef.dot.internal.language.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.gef.dot.internal.language.services.DotColorListGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDotColorListParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NumberSign", "Comma", "Solidus", "Colon", "Semicolon", "RULE_DIGITS", "RULE_ZERO_OR_ONE", "RULE_COLOR_NUMBER", "RULE_HEXADECIMAL_DIGIT", "RULE_COLOR_STRING", "RULE_WS"
    };
    public static final int RULE_WS=14;
    public static final int RULE_COLOR_STRING=13;
    public static final int RULE_DIGITS=9;
    public static final int RULE_ZERO_OR_ONE=10;
    public static final int Semicolon=8;
    public static final int Comma=5;
    public static final int RULE_COLOR_NUMBER=11;
    public static final int NumberSign=4;
    public static final int RULE_HEXADECIMAL_DIGIT=12;
    public static final int Solidus=6;
    public static final int Colon=7;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDotColorListParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDotColorListParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDotColorListParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDotColorListParser.g"; }



     	private DotColorListGrammarAccess grammarAccess;

        public InternalDotColorListParser(TokenStream input, DotColorListGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "ColorList";
       	}

       	@Override
       	protected DotColorListGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleColorList"
    // InternalDotColorListParser.g:57:1: entryRuleColorList returns [EObject current=null] : iv_ruleColorList= ruleColorList EOF ;
    public final EObject entryRuleColorList() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleColorList = null;


        try {
            // InternalDotColorListParser.g:57:50: (iv_ruleColorList= ruleColorList EOF )
            // InternalDotColorListParser.g:58:2: iv_ruleColorList= ruleColorList EOF
            {
             newCompositeNode(grammarAccess.getColorListRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleColorList=ruleColorList();

            state._fsp--;

             current =iv_ruleColorList; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleColorList"


    // $ANTLR start "ruleColorList"
    // InternalDotColorListParser.g:64:1: ruleColorList returns [EObject current=null] : ( ( (lv_colorValues_0_0= ruleWC ) ) (otherlv_1= Colon ( (lv_colorValues_2_0= ruleWC ) ) )* ) ;
    public final EObject ruleColorList() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_colorValues_0_0 = null;

        EObject lv_colorValues_2_0 = null;



        	enterRule();

        try {
            // InternalDotColorListParser.g:70:2: ( ( ( (lv_colorValues_0_0= ruleWC ) ) (otherlv_1= Colon ( (lv_colorValues_2_0= ruleWC ) ) )* ) )
            // InternalDotColorListParser.g:71:2: ( ( (lv_colorValues_0_0= ruleWC ) ) (otherlv_1= Colon ( (lv_colorValues_2_0= ruleWC ) ) )* )
            {
            // InternalDotColorListParser.g:71:2: ( ( (lv_colorValues_0_0= ruleWC ) ) (otherlv_1= Colon ( (lv_colorValues_2_0= ruleWC ) ) )* )
            // InternalDotColorListParser.g:72:3: ( (lv_colorValues_0_0= ruleWC ) ) (otherlv_1= Colon ( (lv_colorValues_2_0= ruleWC ) ) )*
            {
            // InternalDotColorListParser.g:72:3: ( (lv_colorValues_0_0= ruleWC ) )
            // InternalDotColorListParser.g:73:4: (lv_colorValues_0_0= ruleWC )
            {
            // InternalDotColorListParser.g:73:4: (lv_colorValues_0_0= ruleWC )
            // InternalDotColorListParser.g:74:5: lv_colorValues_0_0= ruleWC
            {

            					newCompositeNode(grammarAccess.getColorListAccess().getColorValuesWCParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_3);
            lv_colorValues_0_0=ruleWC();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getColorListRule());
            					}
            					add(
            						current,
            						"colorValues",
            						lv_colorValues_0_0,
            						"org.eclipse.gef.dot.internal.language.DotColorList.WC");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorListParser.g:91:3: (otherlv_1= Colon ( (lv_colorValues_2_0= ruleWC ) ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==Colon) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalDotColorListParser.g:92:4: otherlv_1= Colon ( (lv_colorValues_2_0= ruleWC ) )
            	    {
            	    otherlv_1=(Token)match(input,Colon,FOLLOW_4); 

            	    				newLeafNode(otherlv_1, grammarAccess.getColorListAccess().getColonKeyword_1_0());
            	    			
            	    // InternalDotColorListParser.g:96:4: ( (lv_colorValues_2_0= ruleWC ) )
            	    // InternalDotColorListParser.g:97:5: (lv_colorValues_2_0= ruleWC )
            	    {
            	    // InternalDotColorListParser.g:97:5: (lv_colorValues_2_0= ruleWC )
            	    // InternalDotColorListParser.g:98:6: lv_colorValues_2_0= ruleWC
            	    {

            	    						newCompositeNode(grammarAccess.getColorListAccess().getColorValuesWCParserRuleCall_1_1_0());
            	    					
            	    pushFollow(FOLLOW_3);
            	    lv_colorValues_2_0=ruleWC();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getColorListRule());
            	    						}
            	    						add(
            	    							current,
            	    							"colorValues",
            	    							lv_colorValues_2_0,
            	    							"org.eclipse.gef.dot.internal.language.DotColorList.WC");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleColorList"


    // $ANTLR start "entryRuleWC"
    // InternalDotColorListParser.g:120:1: entryRuleWC returns [EObject current=null] : iv_ruleWC= ruleWC EOF ;
    public final EObject entryRuleWC() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleWC = null;


        try {
            // InternalDotColorListParser.g:120:43: (iv_ruleWC= ruleWC EOF )
            // InternalDotColorListParser.g:121:2: iv_ruleWC= ruleWC EOF
            {
             newCompositeNode(grammarAccess.getWCRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleWC=ruleWC();

            state._fsp--;

             current =iv_ruleWC; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleWC"


    // $ANTLR start "ruleWC"
    // InternalDotColorListParser.g:127:1: ruleWC returns [EObject current=null] : ( ( (lv_color_0_0= ruleColor ) ) (otherlv_1= Semicolon ( (lv_weight_2_0= RULE_COLOR_NUMBER ) ) )? ) ;
    public final EObject ruleWC() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_weight_2_0=null;
        EObject lv_color_0_0 = null;



        	enterRule();

        try {
            // InternalDotColorListParser.g:133:2: ( ( ( (lv_color_0_0= ruleColor ) ) (otherlv_1= Semicolon ( (lv_weight_2_0= RULE_COLOR_NUMBER ) ) )? ) )
            // InternalDotColorListParser.g:134:2: ( ( (lv_color_0_0= ruleColor ) ) (otherlv_1= Semicolon ( (lv_weight_2_0= RULE_COLOR_NUMBER ) ) )? )
            {
            // InternalDotColorListParser.g:134:2: ( ( (lv_color_0_0= ruleColor ) ) (otherlv_1= Semicolon ( (lv_weight_2_0= RULE_COLOR_NUMBER ) ) )? )
            // InternalDotColorListParser.g:135:3: ( (lv_color_0_0= ruleColor ) ) (otherlv_1= Semicolon ( (lv_weight_2_0= RULE_COLOR_NUMBER ) ) )?
            {
            // InternalDotColorListParser.g:135:3: ( (lv_color_0_0= ruleColor ) )
            // InternalDotColorListParser.g:136:4: (lv_color_0_0= ruleColor )
            {
            // InternalDotColorListParser.g:136:4: (lv_color_0_0= ruleColor )
            // InternalDotColorListParser.g:137:5: lv_color_0_0= ruleColor
            {

            					newCompositeNode(grammarAccess.getWCAccess().getColorColorParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_5);
            lv_color_0_0=ruleColor();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getWCRule());
            					}
            					set(
            						current,
            						"color",
            						lv_color_0_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.Color");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorListParser.g:154:3: (otherlv_1= Semicolon ( (lv_weight_2_0= RULE_COLOR_NUMBER ) ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==Semicolon) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDotColorListParser.g:155:4: otherlv_1= Semicolon ( (lv_weight_2_0= RULE_COLOR_NUMBER ) )
                    {
                    otherlv_1=(Token)match(input,Semicolon,FOLLOW_6); 

                    				newLeafNode(otherlv_1, grammarAccess.getWCAccess().getSemicolonKeyword_1_0());
                    			
                    // InternalDotColorListParser.g:159:4: ( (lv_weight_2_0= RULE_COLOR_NUMBER ) )
                    // InternalDotColorListParser.g:160:5: (lv_weight_2_0= RULE_COLOR_NUMBER )
                    {
                    // InternalDotColorListParser.g:160:5: (lv_weight_2_0= RULE_COLOR_NUMBER )
                    // InternalDotColorListParser.g:161:6: lv_weight_2_0= RULE_COLOR_NUMBER
                    {
                    lv_weight_2_0=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_2); 

                    						newLeafNode(lv_weight_2_0, grammarAccess.getWCAccess().getWeightCOLOR_NUMBERTerminalRuleCall_1_1_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getWCRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"weight",
                    							lv_weight_2_0,
                    							"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
                    					

                    }


                    }


                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleWC"


    // $ANTLR start "entryRuleColor"
    // InternalDotColorListParser.g:182:1: entryRuleColor returns [EObject current=null] : iv_ruleColor= ruleColor EOF ;
    public final EObject entryRuleColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleColor = null;


        try {
            // InternalDotColorListParser.g:182:46: (iv_ruleColor= ruleColor EOF )
            // InternalDotColorListParser.g:183:2: iv_ruleColor= ruleColor EOF
            {
             newCompositeNode(grammarAccess.getColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleColor=ruleColor();

            state._fsp--;

             current =iv_ruleColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleColor"


    // $ANTLR start "ruleColor"
    // InternalDotColorListParser.g:189:1: ruleColor returns [EObject current=null] : (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )? ;
    public final EObject ruleColor() throws RecognitionException {
        EObject current = null;

        EObject this_RGBColor_0 = null;

        EObject this_HSVColor_1 = null;

        EObject this_StringColor_2 = null;



        	enterRule();

        try {
            // InternalDotColorListParser.g:195:2: ( (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )? )
            // InternalDotColorListParser.g:196:2: (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )?
            {
            // InternalDotColorListParser.g:196:2: (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )?
            int alt3=4;
            switch ( input.LA(1) ) {
                case NumberSign:
                    {
                    alt3=1;
                    }
                    break;
                case RULE_COLOR_NUMBER:
                    {
                    int LA3_2 = input.LA(2);

                    if ( (LA3_2==EOF||(LA3_2>=Colon && LA3_2<=Semicolon)) ) {
                        alt3=3;
                    }
                    else if ( (LA3_2==Comma||LA3_2==RULE_COLOR_NUMBER) ) {
                        alt3=2;
                    }
                    }
                    break;
                case Solidus:
                case RULE_HEXADECIMAL_DIGIT:
                case RULE_COLOR_STRING:
                    {
                    alt3=3;
                    }
                    break;
            }

            switch (alt3) {
                case 1 :
                    // InternalDotColorListParser.g:197:3: this_RGBColor_0= ruleRGBColor
                    {

                    			newCompositeNode(grammarAccess.getColorAccess().getRGBColorParserRuleCall_0());
                    		
                    pushFollow(FOLLOW_2);
                    this_RGBColor_0=ruleRGBColor();

                    state._fsp--;


                    			current = this_RGBColor_0;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 2 :
                    // InternalDotColorListParser.g:206:3: this_HSVColor_1= ruleHSVColor
                    {

                    			newCompositeNode(grammarAccess.getColorAccess().getHSVColorParserRuleCall_1());
                    		
                    pushFollow(FOLLOW_2);
                    this_HSVColor_1=ruleHSVColor();

                    state._fsp--;


                    			current = this_HSVColor_1;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 3 :
                    // InternalDotColorListParser.g:215:3: this_StringColor_2= ruleStringColor
                    {

                    			newCompositeNode(grammarAccess.getColorAccess().getStringColorParserRuleCall_2());
                    		
                    pushFollow(FOLLOW_2);
                    this_StringColor_2=ruleStringColor();

                    state._fsp--;


                    			current = this_StringColor_2;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleColor"


    // $ANTLR start "entryRuleRGBColor"
    // InternalDotColorListParser.g:227:1: entryRuleRGBColor returns [EObject current=null] : iv_ruleRGBColor= ruleRGBColor EOF ;
    public final EObject entryRuleRGBColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRGBColor = null;


        try {
            // InternalDotColorListParser.g:227:49: (iv_ruleRGBColor= ruleRGBColor EOF )
            // InternalDotColorListParser.g:228:2: iv_ruleRGBColor= ruleRGBColor EOF
            {
             newCompositeNode(grammarAccess.getRGBColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleRGBColor=ruleRGBColor();

            state._fsp--;

             current =iv_ruleRGBColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRGBColor"


    // $ANTLR start "ruleRGBColor"
    // InternalDotColorListParser.g:234:1: ruleRGBColor returns [EObject current=null] : (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? ) ;
    public final EObject ruleRGBColor() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        AntlrDatatypeRuleToken lv_r_1_0 = null;

        AntlrDatatypeRuleToken lv_g_2_0 = null;

        AntlrDatatypeRuleToken lv_b_3_0 = null;

        AntlrDatatypeRuleToken lv_a_4_0 = null;



        	enterRule();

        try {
            // InternalDotColorListParser.g:240:2: ( (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? ) )
            // InternalDotColorListParser.g:241:2: (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? )
            {
            // InternalDotColorListParser.g:241:2: (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? )
            // InternalDotColorListParser.g:242:3: otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )?
            {
            otherlv_0=(Token)match(input,NumberSign,FOLLOW_7); 

            			newLeafNode(otherlv_0, grammarAccess.getRGBColorAccess().getNumberSignKeyword_0());
            		
            // InternalDotColorListParser.g:246:3: ( (lv_r_1_0= rulehex ) )
            // InternalDotColorListParser.g:247:4: (lv_r_1_0= rulehex )
            {
            // InternalDotColorListParser.g:247:4: (lv_r_1_0= rulehex )
            // InternalDotColorListParser.g:248:5: lv_r_1_0= rulehex
            {

            					newCompositeNode(grammarAccess.getRGBColorAccess().getRHexParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_7);
            lv_r_1_0=rulehex();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRGBColorRule());
            					}
            					set(
            						current,
            						"r",
            						lv_r_1_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.hex");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorListParser.g:265:3: ( (lv_g_2_0= rulehex ) )
            // InternalDotColorListParser.g:266:4: (lv_g_2_0= rulehex )
            {
            // InternalDotColorListParser.g:266:4: (lv_g_2_0= rulehex )
            // InternalDotColorListParser.g:267:5: lv_g_2_0= rulehex
            {

            					newCompositeNode(grammarAccess.getRGBColorAccess().getGHexParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_7);
            lv_g_2_0=rulehex();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRGBColorRule());
            					}
            					set(
            						current,
            						"g",
            						lv_g_2_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.hex");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorListParser.g:284:3: ( (lv_b_3_0= rulehex ) )
            // InternalDotColorListParser.g:285:4: (lv_b_3_0= rulehex )
            {
            // InternalDotColorListParser.g:285:4: (lv_b_3_0= rulehex )
            // InternalDotColorListParser.g:286:5: lv_b_3_0= rulehex
            {

            					newCompositeNode(grammarAccess.getRGBColorAccess().getBHexParserRuleCall_3_0());
            				
            pushFollow(FOLLOW_8);
            lv_b_3_0=rulehex();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRGBColorRule());
            					}
            					set(
            						current,
            						"b",
            						lv_b_3_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.hex");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorListParser.g:303:3: ( (lv_a_4_0= rulehex ) )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==RULE_HEXADECIMAL_DIGIT) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalDotColorListParser.g:304:4: (lv_a_4_0= rulehex )
                    {
                    // InternalDotColorListParser.g:304:4: (lv_a_4_0= rulehex )
                    // InternalDotColorListParser.g:305:5: lv_a_4_0= rulehex
                    {

                    					newCompositeNode(grammarAccess.getRGBColorAccess().getAHexParserRuleCall_4_0());
                    				
                    pushFollow(FOLLOW_2);
                    lv_a_4_0=rulehex();

                    state._fsp--;


                    					if (current==null) {
                    						current = createModelElementForParent(grammarAccess.getRGBColorRule());
                    					}
                    					set(
                    						current,
                    						"a",
                    						lv_a_4_0,
                    						"org.eclipse.gef.dot.internal.language.DotColor.hex");
                    					afterParserOrEnumRuleCall();
                    				

                    }


                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRGBColor"


    // $ANTLR start "entryRuleHSVColor"
    // InternalDotColorListParser.g:326:1: entryRuleHSVColor returns [EObject current=null] : iv_ruleHSVColor= ruleHSVColor EOF ;
    public final EObject entryRuleHSVColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleHSVColor = null;


        try {
            // InternalDotColorListParser.g:326:49: (iv_ruleHSVColor= ruleHSVColor EOF )
            // InternalDotColorListParser.g:327:2: iv_ruleHSVColor= ruleHSVColor EOF
            {
             newCompositeNode(grammarAccess.getHSVColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleHSVColor=ruleHSVColor();

            state._fsp--;

             current =iv_ruleHSVColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleHSVColor"


    // $ANTLR start "ruleHSVColor"
    // InternalDotColorListParser.g:333:1: ruleHSVColor returns [EObject current=null] : ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) ) ;
    public final EObject ruleHSVColor() throws RecognitionException {
        EObject current = null;

        Token lv_h_0_0=null;
        Token otherlv_1=null;
        Token lv_s_2_0=null;
        Token otherlv_3=null;
        Token lv_v_4_0=null;


        	enterRule();

        try {
            // InternalDotColorListParser.g:339:2: ( ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) ) )
            // InternalDotColorListParser.g:340:2: ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) )
            {
            // InternalDotColorListParser.g:340:2: ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) )
            // InternalDotColorListParser.g:341:3: ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) )
            {
            // InternalDotColorListParser.g:341:3: ( (lv_h_0_0= RULE_COLOR_NUMBER ) )
            // InternalDotColorListParser.g:342:4: (lv_h_0_0= RULE_COLOR_NUMBER )
            {
            // InternalDotColorListParser.g:342:4: (lv_h_0_0= RULE_COLOR_NUMBER )
            // InternalDotColorListParser.g:343:5: lv_h_0_0= RULE_COLOR_NUMBER
            {
            lv_h_0_0=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_9); 

            					newLeafNode(lv_h_0_0, grammarAccess.getHSVColorAccess().getHCOLOR_NUMBERTerminalRuleCall_0_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getHSVColorRule());
            					}
            					setWithLastConsumed(
            						current,
            						"h",
            						lv_h_0_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
            				

            }


            }

            // InternalDotColorListParser.g:359:3: (otherlv_1= Comma )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==Comma) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // InternalDotColorListParser.g:360:4: otherlv_1= Comma
                    {
                    otherlv_1=(Token)match(input,Comma,FOLLOW_6); 

                    				newLeafNode(otherlv_1, grammarAccess.getHSVColorAccess().getCommaKeyword_1());
                    			

                    }
                    break;

            }

            // InternalDotColorListParser.g:365:3: ( (lv_s_2_0= RULE_COLOR_NUMBER ) )
            // InternalDotColorListParser.g:366:4: (lv_s_2_0= RULE_COLOR_NUMBER )
            {
            // InternalDotColorListParser.g:366:4: (lv_s_2_0= RULE_COLOR_NUMBER )
            // InternalDotColorListParser.g:367:5: lv_s_2_0= RULE_COLOR_NUMBER
            {
            lv_s_2_0=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_9); 

            					newLeafNode(lv_s_2_0, grammarAccess.getHSVColorAccess().getSCOLOR_NUMBERTerminalRuleCall_2_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getHSVColorRule());
            					}
            					setWithLastConsumed(
            						current,
            						"s",
            						lv_s_2_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
            				

            }


            }

            // InternalDotColorListParser.g:383:3: (otherlv_3= Comma )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==Comma) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalDotColorListParser.g:384:4: otherlv_3= Comma
                    {
                    otherlv_3=(Token)match(input,Comma,FOLLOW_6); 

                    				newLeafNode(otherlv_3, grammarAccess.getHSVColorAccess().getCommaKeyword_3());
                    			

                    }
                    break;

            }

            // InternalDotColorListParser.g:389:3: ( (lv_v_4_0= RULE_COLOR_NUMBER ) )
            // InternalDotColorListParser.g:390:4: (lv_v_4_0= RULE_COLOR_NUMBER )
            {
            // InternalDotColorListParser.g:390:4: (lv_v_4_0= RULE_COLOR_NUMBER )
            // InternalDotColorListParser.g:391:5: lv_v_4_0= RULE_COLOR_NUMBER
            {
            lv_v_4_0=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_2); 

            					newLeafNode(lv_v_4_0, grammarAccess.getHSVColorAccess().getVCOLOR_NUMBERTerminalRuleCall_4_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getHSVColorRule());
            					}
            					setWithLastConsumed(
            						current,
            						"v",
            						lv_v_4_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleHSVColor"


    // $ANTLR start "entryRuleStringColor"
    // InternalDotColorListParser.g:411:1: entryRuleStringColor returns [EObject current=null] : iv_ruleStringColor= ruleStringColor EOF ;
    public final EObject entryRuleStringColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleStringColor = null;


        try {
            // InternalDotColorListParser.g:411:52: (iv_ruleStringColor= ruleStringColor EOF )
            // InternalDotColorListParser.g:412:2: iv_ruleStringColor= ruleStringColor EOF
            {
             newCompositeNode(grammarAccess.getStringColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleStringColor=ruleStringColor();

            state._fsp--;

             current =iv_ruleStringColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStringColor"


    // $ANTLR start "ruleStringColor"
    // InternalDotColorListParser.g:418:1: ruleStringColor returns [EObject current=null] : ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) ) ;
    public final EObject ruleStringColor() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_scheme_1_0=null;
        Token otherlv_2=null;
        Token lv_name_3_1=null;
        Token lv_name_3_2=null;
        Token lv_name_3_3=null;


        	enterRule();

        try {
            // InternalDotColorListParser.g:424:2: ( ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) ) )
            // InternalDotColorListParser.g:425:2: ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) )
            {
            // InternalDotColorListParser.g:425:2: ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) )
            // InternalDotColorListParser.g:426:3: (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) )
            {
            // InternalDotColorListParser.g:426:3: (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==Solidus) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // InternalDotColorListParser.g:427:4: otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus
                    {
                    otherlv_0=(Token)match(input,Solidus,FOLLOW_10); 

                    				newLeafNode(otherlv_0, grammarAccess.getStringColorAccess().getSolidusKeyword_0_0());
                    			
                    // InternalDotColorListParser.g:431:4: ( (lv_scheme_1_0= RULE_COLOR_STRING ) )?
                    int alt7=2;
                    int LA7_0 = input.LA(1);

                    if ( (LA7_0==RULE_COLOR_STRING) ) {
                        alt7=1;
                    }
                    switch (alt7) {
                        case 1 :
                            // InternalDotColorListParser.g:432:5: (lv_scheme_1_0= RULE_COLOR_STRING )
                            {
                            // InternalDotColorListParser.g:432:5: (lv_scheme_1_0= RULE_COLOR_STRING )
                            // InternalDotColorListParser.g:433:6: lv_scheme_1_0= RULE_COLOR_STRING
                            {
                            lv_scheme_1_0=(Token)match(input,RULE_COLOR_STRING,FOLLOW_11); 

                            						newLeafNode(lv_scheme_1_0, grammarAccess.getStringColorAccess().getSchemeCOLOR_STRINGTerminalRuleCall_0_1_0());
                            					

                            						if (current==null) {
                            							current = createModelElement(grammarAccess.getStringColorRule());
                            						}
                            						setWithLastConsumed(
                            							current,
                            							"scheme",
                            							lv_scheme_1_0,
                            							"org.eclipse.gef.dot.internal.language.DotColor.COLOR_STRING");
                            					

                            }


                            }
                            break;

                    }

                    otherlv_2=(Token)match(input,Solidus,FOLLOW_12); 

                    				newLeafNode(otherlv_2, grammarAccess.getStringColorAccess().getSolidusKeyword_0_2());
                    			

                    }
                    break;

            }

            // InternalDotColorListParser.g:454:3: ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) )
            // InternalDotColorListParser.g:455:4: ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) )
            {
            // InternalDotColorListParser.g:455:4: ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) )
            // InternalDotColorListParser.g:456:5: (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER )
            {
            // InternalDotColorListParser.g:456:5: (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER )
            int alt9=3;
            switch ( input.LA(1) ) {
            case RULE_HEXADECIMAL_DIGIT:
                {
                alt9=1;
                }
                break;
            case RULE_COLOR_STRING:
                {
                alt9=2;
                }
                break;
            case RULE_COLOR_NUMBER:
                {
                alt9=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // InternalDotColorListParser.g:457:6: lv_name_3_1= RULE_HEXADECIMAL_DIGIT
                    {
                    lv_name_3_1=(Token)match(input,RULE_HEXADECIMAL_DIGIT,FOLLOW_2); 

                    						newLeafNode(lv_name_3_1, grammarAccess.getStringColorAccess().getNameHEXADECIMAL_DIGITTerminalRuleCall_1_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getStringColorRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_3_1,
                    							"org.eclipse.gef.dot.internal.language.DotColor.HEXADECIMAL_DIGIT");
                    					

                    }
                    break;
                case 2 :
                    // InternalDotColorListParser.g:472:6: lv_name_3_2= RULE_COLOR_STRING
                    {
                    lv_name_3_2=(Token)match(input,RULE_COLOR_STRING,FOLLOW_2); 

                    						newLeafNode(lv_name_3_2, grammarAccess.getStringColorAccess().getNameCOLOR_STRINGTerminalRuleCall_1_0_1());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getStringColorRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_3_2,
                    							"org.eclipse.gef.dot.internal.language.DotColor.COLOR_STRING");
                    					

                    }
                    break;
                case 3 :
                    // InternalDotColorListParser.g:487:6: lv_name_3_3= RULE_COLOR_NUMBER
                    {
                    lv_name_3_3=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_2); 

                    						newLeafNode(lv_name_3_3, grammarAccess.getStringColorAccess().getNameCOLOR_NUMBERTerminalRuleCall_1_0_2());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getStringColorRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_3_3,
                    							"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
                    					

                    }
                    break;

            }


            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStringColor"


    // $ANTLR start "entryRulehex"
    // InternalDotColorListParser.g:508:1: entryRulehex returns [String current=null] : iv_rulehex= rulehex EOF ;
    public final String entryRulehex() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_rulehex = null;


        try {
            // InternalDotColorListParser.g:508:43: (iv_rulehex= rulehex EOF )
            // InternalDotColorListParser.g:509:2: iv_rulehex= rulehex EOF
            {
             newCompositeNode(grammarAccess.getHexRule()); 
            pushFollow(FOLLOW_1);
            iv_rulehex=rulehex();

            state._fsp--;

             current =iv_rulehex.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulehex"


    // $ANTLR start "rulehex"
    // InternalDotColorListParser.g:515:1: rulehex returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT ) ;
    public final AntlrDatatypeRuleToken rulehex() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_HEXADECIMAL_DIGIT_0=null;
        Token this_HEXADECIMAL_DIGIT_1=null;


        	enterRule();

        try {
            // InternalDotColorListParser.g:521:2: ( (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT ) )
            // InternalDotColorListParser.g:522:2: (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT )
            {
            // InternalDotColorListParser.g:522:2: (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT )
            // InternalDotColorListParser.g:523:3: this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT
            {
            this_HEXADECIMAL_DIGIT_0=(Token)match(input,RULE_HEXADECIMAL_DIGIT,FOLLOW_7); 

            			current.merge(this_HEXADECIMAL_DIGIT_0);
            		

            			newLeafNode(this_HEXADECIMAL_DIGIT_0, grammarAccess.getHexAccess().getHEXADECIMAL_DIGITTerminalRuleCall_0());
            		
            this_HEXADECIMAL_DIGIT_1=(Token)match(input,RULE_HEXADECIMAL_DIGIT,FOLLOW_2); 

            			current.merge(this_HEXADECIMAL_DIGIT_1);
            		

            			newLeafNode(this_HEXADECIMAL_DIGIT_1, grammarAccess.getHexAccess().getHEXADECIMAL_DIGITTerminalRuleCall_1());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulehex"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000082L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000003950L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000102L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000000820L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000002040L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000003800L});

}